; color-mate.el Starts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   Color-Mate  Ver.7.02
;;         by  ͵ (y5t0964@students.chiba-u.ac.jp)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   Coloring mule/emacs to more easier and more fun.
;;   mule / emacs ǡѤƸ䤹̤ˤޤ
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;$Id: color-mate.el,v 7.7 1996/05/25 19:00:33 elca Exp $

;; -*-mode: emacs-lisp-*-

;;
;; Color-Mate.el
;;

;----------------;
; Сɽ
;----------------;
(defconst color-mate-version-string "Color-Mate Ver.7.02 based on mule Ver.2.3 / emacs Ver.19.29 : color-mate.el 1996/May/25")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                       СɽѴؿ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun color-mate-version ()
  (interactive)
  (message (concat (substring color-mate-version-string 0 72) " ...")) )

;----------------------------------------------------------------------;
;                         Color-Mate ѿ
;----------------------------------------------------------------------;
;; 
;; for mule Ver.2 / emacs Ver.19
; modeline
(defvar color-mate-modeline-underlined t
  "Modeline underlined (t/nil)")
(defvar color-mate-modeline-background-color "green4"
  "Modeline background color (color name)")
(defvar color-mate-modeline-foreground-color "white"
  "Modeline foreground color (color name)")

; region
(defvar color-mate-region-underlined nil
  "Region underlined (t/nil)")
(defvar color-mate-region-background-color "white"
  "Region background color (color name)")
(defvar color-mate-region-foreground-color "navy"
  "Region foreground color (color name)")

; frame
(defvar color-mate-frame-background-color "AntiqueWhite"
  "Frame background color (color name)")
(defvar color-mate-frame-foreground-color "black"
  "Frame foreground color (color name)")
(defvar color-mate-frame-height 40
  "Frame height (number)")
(defvar color-mate-frame-width 80
  "Frame width (number)")

; cursor
(defvar color-mate-cursor-color "navy"
  "Cursor color (color name)")

; mouse cursor
(defvar color-mate-mouse-color "red"
  "Mouse cursor color (color name)")

; menu bar
(defvar color-mate-menu-bar-lines 1
  "Use menu bar (1=use/0=not use)")

; font set / font
(defvar color-mate-mule-font "default-fontset"
  "Default font set name (For mule only)")
(defvar color-mate-mule-font "9x15"
  "Default font name (For emacs only)")

; misc
(defvar color-mate-line-space "1+1"
  "Space between text lines (ex. \"0+0\")")
(defvar color-mate-face-modify t
  "Use modified face with hilit19 and font-lock.
If you use your own faces, please set nil.")


;; local
(defvar color-mate-frame-alist nil
  "Color-Mate's local alist. Don't use it!")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                        ؿ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ؿΡmule/emacs ˿ɤ롣
;
(defun color-mate ()
  "Coloring mule/emacs. Be careful to using different settings between
mule ver.2/emacs ver.19 and mule ver.1/emacs ver.18"
  (if window-system
      (progn
	(color-mate-set-default-frame)
;;	(color-mate-set-current-frame)
	)
    (progn
      (message "color-mate.el requires window system. stop.")
      )
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;               ե졼δͤ롣
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ե졼δͤ롣â⡼ɥ饤ȥ꡼
; ϻ;ͤǤʤߤΥե졼οˤȿǤ롣
;
(defun color-mate-set-default-frame ()
  "Set default settings to coloring mule/emacs. Be careful to using
different settings between mule ver.2/emacs ver.19 and mule ver.1/emacs ver.18"
  
  (if (and (>= (string-to-int emacs-version) 19)
	   window-system )
      (progn
	
	;; ⡼ɥ饤ϰϤο
	;; color-mate-set-current-frame Ʊ
	;; ϴͤǤʤߤΥե졼οˤȿǤ
	(set-face-underline-p 'modeline color-mate-modeline-underlined)
	(set-face-background  'modeline color-mate-modeline-background-color)
	(set-face-foreground  'modeline color-mate-modeline-foreground-color)
	(set-face-underline-p 'region   color-mate-region-underlined)
	(set-face-background  'region   color-mate-region-background-color)
	(set-face-foreground  'region   color-mate-region-foreground-color)
	
        ;; ɥεͤ򥢥ꥹȤˤϿ
        ;; ɲä褦ˤ
	(setq color-mate-frame-alist
	      (list
	       (cons 'background-color  color-mate-frame-background-color)
	       (cons 'foreground-color  color-mate-frame-foreground-color)
	       (cons 'cursor-color      color-mate-cursor-color)
	       (cons 'mouse-color       color-mate-mouse-color)
	       (cons 'menu-bar-lines    color-mate-menu-bar-lines)
	       (cons 'height            color-mate-frame-height)
	       (cons 'width             color-mate-frame-width)
	       (cons 'line-space        color-mate-line-space))
	      )
	
	(if (boundp 'MULE)  ;; mule ˤϴեȤɲ
	    (setq color-mate-frame-alist
		  (cons
		   (cons 'font          color-mate-mule-font)
		   color-mate-frame-alist))
			    ;; emacs ˤϥ޻եȤɲ
	  (setq color-mate-frame-alist
		(cons
		 (cons 'font            color-mate-emacs-font)
		 color-mate-frame-alist))
	  )
	
	(setq default-frame-alist             ;; ɥεͤϿ
	      (append color-mate-frame-alist  ;; ɲ
		      default-frame-alist))
;;	(setq initial-frame-alist             ;; ιԤ̵Ƥɤ
;;	      (append color-mate-frame-alist  ;; 񤤤Ƥ
;;		      initial-frame-alist))
	)
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                 ߤΥե졼οѹ롣
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ߤΥե졼Ρѹ롣δؿˤäƿѤΤ
; ߤΥե졼Ǥꡢcolor-mate-set-default-frame ˤä
; 줿ͤΥꥹȤˤˤϱƶʤ
;
(defun color-mate-set-current-frame ()
  "Coloring current frame. Be careful to using different settings between
mule ver.2/emacs ver.19 and mule ver.1/emacs ver.18"
  
  (if (and (>= (string-to-int emacs-version) 19)
	   window-system )
      (progn
	(set-face-underline-p 'modeline color-mate-modeline-underlined)
	(set-face-background  'modeline color-mate-modeline-background-color)
	(set-face-foreground  'modeline color-mate-modeline-foreground-color)
	(set-face-underline-p 'region   color-mate-region-underlined)
	(set-face-background  'region   color-mate-region-background-color)
	(set-face-foreground  'region   color-mate-region-foreground-color)
	(set-background-color           color-mate-frame-background-color)
	(set-foreground-color           color-mate-frame-foreground-color)
	(set-cursor-color               color-mate-cursor-color)
	(set-mouse-color                color-mate-mouse-color)
	)
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                  󥿥饯ƥѴؿ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 󥿥饯ƥˤäͤƤ줾ѿ
;  color-mate-set-current-frame ؿˤäƸߤΥե졼ο
; ѹ롣
;
(defun color-mate-set-color ( modeline-bg modeline-fg
			      region-bg   region-fg
			      frame-bg    frame-fg
			      cursor
			      mouse )
  "Change current frame color interactively. (mule2/emacs19)
Just press return key to use old value."
  
  ; ͤ롣ͤǥեͤȤɽ롣
  (interactive
   (list
    (completing-read
     (format "Modeline background color (default %s): "
	     color-mate-modeline-background-color) nil nil nil nil nil)
    (completing-read
     (format "Modeline foreground color (default %s): "
	     color-mate-modeline-foreground-color) nil nil nil nil nil)
    (completing-read
     (format "Region background color (default %s): "
	     color-mate-region-background-color)   nil nil nil nil nil)
    (completing-read
     (format "Region foreground color (default %s): "
	     color-mate-region-foreground-color)   nil nil nil nil nil)
    (completing-read
     (format "Frame background color (default %s): "
	     color-mate-frame-background-color)    nil nil nil nil nil)
    (completing-read
     (format "Frame foreground color (default %s): "
	     color-mate-frame-foreground-color)    nil nil nil nil nil)
    (completing-read
     (format "Cursor color (default %s): "
	     color-mate-cursor-color)              nil nil nil nil nil)
    (completing-read
     (format "Mouse cursor name (default %s): "
	     color-mate-mouse-color)               nil nil nil nil nil)
    ))
  
  (if (and (>= (string-to-int emacs-version) 19)
	   window-system )
      (progn
 	
	; ͤꤵƤФͤ򡢤ƤʤͤѤ
	(if (not (equal modeline-bg  ""))
	    (setq color-mate-modeline-background-color modeline-bg))
	(if (not (equal modeline-fg  ""))
	    (setq color-mate-modeline-foreground-color modeline-fg))
	
	(if (not (equal region-bg    ""))
	    (setq color-mate-region-background-color   region-bg))
	(if (not (equal region-fg    ""))
	    (setq color-mate-region-foreground-color   region-fg))
	
	(if (not (equal frame-bg     ""))
	    (setq color-mate-frame-background-color    frame-bg))
	(if (not (equal frame-fg     ""))
	    (setq color-mate-frame-foreground-color    frame-fg))
	
	(if (not (equal cursor       ""))
	    (setq color-mate-cursor-color              cursor))
	(if (not (equal mouse        ""))
	    (setq color-mate-mouse-color               mouse))
	
	;; 忧
;;	(color-mate-set-default-frame)
	(color-mate-set-current-frame)
	)
      )
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                          ʸؤ忧
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; hilit19  font-lock Ȥäʸ忧롣
;; Canna ȤäƤʤ顢 Canna 忧ǽͭˤ롣
;;

;; font-lock Ѥɲꡣ (mule FAQ )
; Color-Mate  hilit19  font-lock Ʊ˻ѤƤΤǡ
; δ֤ǤĴΤʸΥ顼򾡼˽񤭴Ƥޤ
; ⤷ʤ hilit19  font-lock ȤäƤʤ顢꤬Ѥä
; ޤ줬ޤλ
;
;   (setq color-mate-face-modify nil)
;
; ȤƤεǽȤʤ褦ˤƲ

;------------------------------;
; mule Ver.2/emacs Ver.19 
;------------------------------;
(if (and (>= (string-to-int emacs-version) 19) ; mule Ver.2/emacs Ver.19 
	 window-system                         ; ǥɥƥ
	 color-mate-face-modify )              ; Ѥcolor-mate-face-
					       ; modify  t λΤߵư롣
    (progn
      
      (require 'hilit19)        ;; ʸ˿դ
      (require 'font-lock)      ;; ˿դ
      
      ;; mule  font-lock μưƤӤ롼󤬤ʤΤɲä롣
      (if (boundp 'MULE)
	  (defun turn-on-font-lock ()
	    "Hook routine for font-lock. (By color-mate.el)"
	    (font-lock-mode 1)))
      
      (add-hook 'find-file-hooks 'turn-on-font-lock)  ;; ʸ忧ư
      
      ;; canna 忧ǽͭˤ롣
      ;; Canna  mule Ǥ canna.el ˤ˥ɤƤΤ
      ;; (featurep 'canna) Ǥ (canna) ¹Ԥʬʤ
      ;; 忧ǽͭˤ뤿̵ Canna Ƶư롣
      (if (and (boundp 'CANNA) CANNA)
	  (progn
	    (setq canna-use-color t)
	    (progn
	      (cond
	       ((boundp 'egg-version)
		(require 'can-n-egg)
		(can-n-egg))
	       (t
		(require 'canna)
		(canna))
	       )
	      )
	    )
	)
      
      ;------------------;
      ; font-lock 
      ;------------------;
      ; hilit19 Ʊˤʤ褦ˤ
      ;
      ; mule  emacs Ƕ̤˻Ȥ褦ʥܡɥեȤץब
      ; ޤưʤʤȤʤʤΤ
      ;
      (if (boundp 'MULE)
	  ; mule ѤΥ롼
	  (progn
	    (add-hook 'font-lock-mode-hook
		      '(lambda ()
			 ; øˤ define ѿ̾ʤ
			 (make-face           'keyword-face)
			 (set-face-foreground 'keyword-face "purple")
			 (set-face-bold-p     'keyword-face t)
			 (setq font-lock-keyword-face 'keyword-face)
			 
			 ; 
			 (make-face           'comment-face)
			 (set-face-foreground 'comment-face "firebrick")
			 (setq font-lock-comment-face 'comment-face)
			 
			 ; ʸ
			 (make-face            'string-face)
			 (set-face-foreground  'string-face "grey40")
			 (set-face-underline-p 'string-face t)
			 (setq font-lock-string-face 'string-face)
			 
			 ; ؿ̾
			 (make-face           'function-face)
			 (set-face-foreground 'function-face "blue")
			 (set-face-bold-p     'function-face t)
			 (setq font-lock-function-name-face 'function-face)
			 
			 ; ѿ
			 (make-face           'c-type-face)
			 (set-face-foreground 'c-type-face "RoyalBlue")
			 (setq font-lock-type-face 'c-type-face)
			 ))
	    )
	
	; emacs ѤΥ롼
	(progn
	  ; եȺ
	  (make-face            'keyword-face)
	  (set-face-foreground  'keyword-face "purple")
	  (make-face-bold       'keyword-face)
	  
	  (make-face            'comment-face)
	  (set-face-foreground  'comment-face "firebrick")
	  
	  (make-face            'string-face)
	  (set-face-foreground  'string-face "grey40")
	  (set-face-underline-p 'string-face t)
	  
	  (make-face            'function-face)
	  (set-face-foreground  'function-face "blue")
	  (make-face-bold       'function-face)
	  
	  (make-face            'c-type-face)
	  (set-face-foreground  'c-type-face "RoyalBlue")
	  
	  ; 
	  (add-hook 'font-lock-mode-hook
		    '(lambda ()
		       ; øˤ define ѿ̾ʤ
		       (setq font-lock-keyword-face       'keyword-face)
		       
		       ; 
		       (setq font-lock-comment-face       'comment-face)
		       
		       ; ʸ
		       (setq font-lock-string-face        'string-face)
		       
		       ; ؿ̾
		       (setq font-lock-function-name-face 'function-face)
		       
		       ; ѿ
		       (setq font-lock-type-face          'c-type-face)
		       ))
	  )
	)
      
      ;----------------;
      ; hilit19 
      ;----------------;
      ; hilit19 ɲ忧
      ; ø int ʤɤѿؤ忧
      (hilit-translate type     'RoyalBlue)
      
      )
  )


;-------------------------;
; Color-Mate ư롣
;-------------------------;
(color-mate)

(provide 'color-mate) ; feature ȤϿ

; color-mate.el Ends
