; color-mate18.el Starts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   Color-Mate  Ver.7.02
;;         by  ͵ (y5t0964@students.chiba-u.ac.jp)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   Coloring mule/emacs to more easier and more fun.
;;   mule / emacs ǡѤƸ䤹̤ˤޤ
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;$Id: color-mate18.el,v 7.6 1996/05/25 18:27:42 elca Exp $

;; -*-mode: emacs-lisp-*-

;;
;; Color-Mate18.el
;;

;----------------;
; Сɽ
;----------------;
(defconst color-mate-version-string "Color-Mate Ver.7.02 based on mule Ver.1.1 / emacs Ver.18.59 : color-mate18.el 1996/May/25")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                       СɽѴؿ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun color-mate-version ()
  (interactive)
  (message (concat (substring color-mate-version-string 0 72) " ...")) )

;----------------------------------------------------------------------;
;                         Color-Mate ѿ
;----------------------------------------------------------------------;
;; 
;; for mule Ver.1 / emacs Ver.18
(defvar color-mate-v18-background-color color-mate-frame-background-color
  "Background color for mule v1/emacs v18 (color name)")
(defvar color-mate-v18-foreground-color "blue"
  "Foreground color for mule v1/emacs v18 (color name)")
(defvar color-mate-v18-cursor-color     "navy"
  "Cursor color for mule v1/emacs v18 (color name)")
(defvar color-mate-v18-mouse-color      "red"
  "Mouse cursor color for mule v1/emacs v18 (color name)")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                        ؿ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ؿΡmule/emacs ˿ɤ롣
;
(defun color-mate ()
  "Coloring mule/emacs. Be careful to using different settings between
mule ver.2/emacs ver.19 and mule ver.1/emacs ver.18"
  (if window-system
      (progn
	(color-mate-set-current-frame)
	)
    (progn
      (message "color-mate18.el requires window system. stop.")
      )
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                      ե졼οѹ롣
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ե졼οѹ롣
;
(defun color-mate-set-current-frame ()
  "Coloring current frame. Be careful to using different settings between
mule ver.2/emacs ver.19 and mule ver.1/emacs ver.18"
  
  ; mule Ver.1 / emacs Ver.18 
  (if (and (< (string-to-int emacs-version) 19)
	   window-system )
      (progn
	(x-set-background-color color-mate-v18-background-color)
	(x-set-foreground-color color-mate-v18-foreground-color)
	(x-set-cursor-color     color-mate-v18-cursor-color)
	(x-set-mouse-color      color-mate-v18-mouse-color)
	)
    )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                  󥿥饯ƥѴؿ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 󥿥饯ƥˤäͤƤ줾ѿ
;  color-mate-set-current-frame ؿˤäƥե졼ο
; ѹ롣
;
(defun color-mate-set-color (bg fg cursor mouse)
  "Change current frame color interactively. (mule1/emacs18)
Just press return key to use old value."
  
  ; ͤ롣ͤǥեͤȤɽ롣
  (interactive
   (list
    (completing-read
     (format "Background color (default %s): "
	     color-mate-v18-background-color) nil nil nil nil nil)
    (completing-read
     (format "Foreground color (default %s): "
	     color-mate-v18-foreground-color) nil nil nil nil nil)
    (completing-read
     (format "Cursor color (default %s): "
	     color-mate-v18-cursor-color)     nil nil nil nil nil)
    (completing-read
     (format "Mouse cursor name (default %s): "
	     color-mate-v18-mouse-color)      nil nil nil nil nil)
    ))
  
  (if (and (< (string-to-int emacs-version) 19)
	   window-system )
      (progn
	; ͤꤵƤФͤ򡢤ƤʤͤѤ
	(if (not (equal bg     ""))
	    (setq color-mate-v18-background-color bg))
	(if (not (equal fg     ""))
	    (setq color-mate-v18-foreground-color fg))
	(if (not (equal cursor ""))
	    (setq color-mate-v18-cursor-color     cursor))
	(if (not (equal mouse  ""))
	    (setq color-mate-v18-mouse-color      mouse))
	
	;; 忧
	(color-mate-set-current-frame)
	)
      )
  )


;-------------------------;
; Color-Mate ư롣
;-------------------------;
(color-mate)

(provide 'color-mate18) ; feature ȤϿ

; color-mate18.el Ends
